#include <stdlib.h>
#include <iostream.h>

int MaxBit = 31;
struct Tree_node {
  union {
    int value;              // the exact value and it's key will be saved in the same
    int key;                 // memory area
   };
  unsigned char B;                // bit number to be considerated
  Tree_node * left;               // left branch
  Tree_node * right;              // right branch
 };

typedef struct Tree_node *Ptree;
//In order to evaluete the k bit in value x typecasting need to be made
 char bit(int x, unsigned char k) {
  int b = *((int*)&x);
  return (b >> k) & 1;
 }

Ptree Pat_search (int _new, Ptree t) {
 Ptree p;
 if (t!=NULL) do  //is given Patricia tree empty?
  {
    p=t;          //temporary variable
    if (bit(_new,t->B))
       t=t->right;
    else
       t=t->left;   //which branch must be chosen
   } while ((t!=NULL)&&( p->B  >   t->B));
 if (t!=NULL)
   if (t->value != _new) t=NULL;
 return t;
}
/*If _new ISN'T in the given Patricia tree the function returns NULL
else function returns a pointer to the same value in the Patricia tree
as given _new  */

Ptree Pat_insert (int _new, Ptree tree) {
     Ptree temp;
     Ptree t;
     Ptree head;
     unsigned char minBit,newBitNumber,found;

 if (Pat_search(_new,tree)!=NULL)
    return tree;

 if (tree==NULL) {          // Is given patricia tree empty?
    tree = new (Tree_node); // YES? Then new(and only in this case) value is being inserted
    tree->B = MaxBit;
    tree->value = _new;
    tree->left = NULL;
    tree->right = NULL;
    if (bit(_new,tree->B))
       tree->right = tree;
    else
       tree->left = tree;
    return tree;
 }
  head=tree;                  //NO? then much more difficult case
                              // saving the current head
 do {
     if (bit(_new,tree->B))
        temp = tree->right;    // temp goes down the given Patricia tree
     else
        temp = tree->left;
     found = 0;                // "founding" place
     newBitNumber = tree->B-1; // oncoming Tree_node bit number (t->B)
     if (temp==NULL)
        found = 1;             //hurray, the place to insert was founded
     else if (temp->B >= tree->B)      //condition that lower branch
        minBit = 0;                    //wouldn't have greater bit number
     else
        minBit = temp->B+1;
     while ((!found)&&(newBitNumber>=minBit))
           if (bit(_new,newBitNumber) == bit(temp->value,newBitNumber))
              newBitNumber--;
           else
              found = 1;

    if (found) {                //as the place to insert was founded function
       t = new(Tree_node);         //begins to do that
	   t->value = _new;
       t->B=newBitNumber;

       
	   if (bit(t->value,t->B)) {           //checks whick branch to choose
          t->right = t;
	      t->left = temp;
       }
	   else {
          t->right = temp;
	      t->left = t;
       }
	   if (bit(_new,tree->B))
          tree->right = t;
	   else
          tree->left=t;
	}
	else if (tree->right==temp)
       tree=tree->right;
	else
       tree=tree->left;
 } while (!found);
 return head;              // returns the root of tree
}

// First of all procedure prints a root (head), then right branch an in the end
// the left branch
 void print (Ptree tree)
{
  if (tree!=NULL) {
     cout << tree->value << endl;
     if ((tree->right != NULL)&&(tree->right->B < tree->B))
        print(tree->right);
     if ((tree->left != NULL)&&(tree->left->B < tree->B))
        print(tree->left);
  }
}
main() {
 Ptree YourTREE = NULL;
 int elem;
 int N, i;

 cout <<"Kiek elem tures medis?" << endl;
 cin >> N;
  for(i=0; i<N; i++) {
  cout << "Iveskite " << i+1 << " elem.  verte: ";
  cin >> elem;
    YourTREE = Pat_insert(elem, YourTREE);
    }
 cout << "Medis atrodys: " << endl;
 print(YourTREE);
 cout << "Pabaiga" << endl;
}



